/*
 * Copyright (C) 2019  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "src/diagnostics/about_reply.hh"

#include "src/util/struct_to_string.hh"

namespace Fred {
namespace Registry {
namespace Diagnostics {

std::string AboutReply::Version::to_string()const
{
    return Util::StructToString().add("full", full)
                                 .add("major", major)
                                 .add("minor", minor)
                                 .add("patch", patch)
                                 .add("rc", rc)
                                 .add("commit", commit)
                                 .finish();
}

std::string AboutReply::Version::Commit::to_string()const
{
    return Util::StructToString().add("distance", distance)
                                 .add("hash", hash)
                                 .finish();
}

std::string AboutReply::Data::to_string()const
{
    return Util::StructToString().add("api_version", api_version)
                                 .add("server_version", server_version)
                                 .finish();
}

}//namespace Fred::Registry::Diagnostics
}//namespace Fred::Registry
}//namespace Fred
