/*
 * Copyright (C) 2019  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef KEYSET_INFO_REPLY_HH_1DD0CDDA65D44C96AC5D7DECAEE57865
#define KEYSET_INFO_REPLY_HH_1DD0CDDA65D44C96AC5D7DECAEE57865

#include "src/contact/contact_common_types.hh"
#include "src/exceptions.hh"
#include "src/keyset/keyset_common_types.hh"
#include "src/keyset/keyset_info_request.hh"
#include "src/object/object_common_types.hh"
#include "src/util/printable.hh"

#include <boost/optional.hpp>

#include <string>
#include <vector>

namespace Fred {
namespace Registry {
namespace Keyset {

struct KeysetInfoReply
{
    struct Data : Util::Printable<Data>
    {
        KeysetHandle keyset_handle;
        KeysetId keyset_id;
        KeysetHistoryId keyset_history_id;
        std::vector<DnsKey> dns_keys;
        std::vector<Contact::ContactId> technical_contacts;
        AuthInfo auth_info;
        Object::ObjectEvents representative_events;
        std::string to_string() const;
    };
    struct Exception
    {
        struct KeysetDoesNotExist : Registry::Exception
        {
            explicit KeysetDoesNotExist(const KeysetInfoRequest& src);
        };
    };
};

} // namespace Fred::Registry::Keyset
} // namespace Fred::Registry
} // namespace Fred

#endif
